									   ;
					; Programming Trivia V0.4.5.4 Pre-Alpha
									   ;
		; Authors:	Brandon	Olivares <ph-webmaster@programmershaven.org>
			   ; Project Website:  http://ptrivia.sourceforge.net
									   ;
									   ;
		 ; A trivia	game to	test the knowledge and skill of	programmers
		  ;	Copyright (C) 2004	Brandon	Olivares, all rights reserved.
									   ;
	 ; This	program	is free	software; you can redistribute it and/or modify
	 ; it under	the	terms of the GNU General Public	License	as published by
	  ;	the	Free Software Foundation; either version 2 of the License, or
					 ; (at your	option)	any	later version.
									   ;
	   ; This program is distributed in	the	hope that it will be useful,
		; but WITHOUT ANY WARRANTY;	without	even the implied warranty of
		; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See	the
				 ; GNU General Public License for more details.
									   ;
	  ;	You	should have	received a copy	of the GNU General Public License
		 ; along with this program;	if not,	write to the Free Software
  ;	Foundation,	Inc., 59 Temple	Place, Suite 330, Boston, MA  02111-1307  USA
									   ;
									   ;
	  ;	To contact us, send	an e-mail to ph-webmaster@programmershaven.org
									   ;
									   ;
								  ;	trivia.asm
									   ;
				  ;	This is	the	main project file.	Including
					; the declaration for WinMain, WndProc,
						 ; and some	helper procedures.
									   ;


.486
.model flat,stdcall
option casemap:none

include	trivia.inc										   ; trivia	include	file


.data
ClassName db "programming_trivia",0					; name of the window's class
align 4

statusParts		dd 7 dup (0)											; The 7	parts of the status		bar

gamesWon db	"0 won",0											; number of	games won
align 4

gamesLost db "0	lost",0											; Number of	games lost
align 4

AppName	 db	"Programming Trivia",0												; Window title
align 4

helpFileName db	"trivia.chm",0					; Name of the help file	(*.chm)
align 4

libOpenFailureTitle	db "Error Opening Library",0		; error	message
														; on lib open failure
libFuncFailureTitle	db "Internal Library Error",0		; Unable to	find the
														; function

.data?
hInstance HINSTANCE	?							; Window instance
CommandLine	LPSTR ?								; command line information
hStatus	HWND ?							; Status bar handle
initHelp dd	?							; HTML Help	API	instance


.code


; ---------------------------------------------------------------------------


start:

call InitCommonControls							; for status bar etc

invoke GetModuleHandle,	NULL							; Retrieve the
mov	   hInstance,eax									; application instance

invoke GetCommandLine							; Get command line information
mov	   CommandLine,eax

												; ------------------------------
									   ; Invoke	main function of the application
												; ------------------------------
invoke WinMain,	hInstance,NULL,CommandLine,	SW_SHOWDEFAULT


												; ------------------------------
															 ; exit, returning 0
												; ------------------------------
invoke ExitProcess,eax


									   ;
								   ; WinMain
									   ;
						  ;	Main application function
									   ;
									   ;
				   ; This function registers the window	class
					 ; creates and displays	the	window,	and
						; goes through the message loop.
									   ;
									   ;
								 ; Parameters:
									   ;
					; hInst:HINSTANCE -	application	instance
		 ; hPrevInst:HINSTANCE - previous instance - is	generally NULL
					 ; CmdLine:LPSTR - command line	string
					; CmdShow:DWORD	- What state to	display
						;				  the window in
									   ;
									   ;
								; Return value:
							; On success, returns 0
									   ;
WinMain	proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

	LOCAL wc:WNDCLASSEX							; WNDCLASSEX structure
	LOCAL msg:MSG								; MSG structure	for	window
												; messages
	LOCAL hwnd:HWND								; Window handle

	mov	  wc.cbSize,SIZEOF WNDCLASSEX							; Class	size
	mov	  wc.style,	CS_HREDRAW or CS_VREDRAW					; Window style
	mov	  wc.lpfnWndProc, OFFSET WndProc				; Window procedure
	mov	  wc.cbClsExtra,NULL					; Extra	membory	after structure
	mov	  wc.cbWndExtra,NULL					; Extra	memory after window

	push  hInstance								; Retrieve application instance
	pop	  wc.hInstance

	mov	  wc.hbrBackground,COLOR_BTNFACE+1				; Background color of
														; window
	mov	  wc.lpszMenuName,IDR_MENU								; Menu handle
																; for this class
	mov	  wc.lpszClassName,OFFSET ClassName						; class	name

	invoke LoadIcon,NULL,IDI_APPLICATION						; Load the icon
	mov	  wc.hIcon,eax
	mov	  wc.hIconSm,eax								; small	icon

	invoke LoadCursor,NULL,IDC_ARROW							; Load the
	mov	  wc.hCursor,eax										; cursor


	invoke RegisterClassEx,	addr wc						; Register the class

	invoke CreateWindowEx,NULL,\		; No extended styles
	ADDR ClassName,\					; Window's class name
	ADDR AppName,\						; Window title
	WS_OVERLAPPEDWINDOW,\				; Window style
	CW_USEDEFAULT,\						; Default X
	CW_USEDEFAULT,\						; Default Y
	CW_USEDEFAULT,\						; Default width
	CW_USEDEFAULT,\						; Default height
	NULL,\								; Parent window
	NULL,\								; Menu (already	specified in class)
	hInst,\								; Window instance
	NULL								; Extra	data

	mov	  hwnd,eax

	invoke ShowWindow, hwnd,SW_SHOWNORMAL				; Show the window
	invoke UpdateWindow, hwnd			; Paint	it

  startMsgLoop:							; The message loop

												; ------------------------------
														  ;	Retrieve the message
												; ------------------------------
	invoke GetMessage, ADDR	msg,NULL,0,0

	test eax, eax								; Exit the loop	if
	jz endMsgLoop								; eax is 0

												; ------------------------------
										   ; if	message	is for the HTML	Help API
												; ------------------------------
	invoke HtmlHelp,NULL,NULL,00FDh,addr msg
	test eax, eax						; top of loop if
	jnz	startMsgLoop					; the HTML Help	API	handles	the	message

	invoke TranslateMessage, ADDR msg					; Translate	to ascii
	invoke DispatchMessage,	ADDR msg					; And send
	jmp	startMsgLoop							; jump to top

  endMsgLoop:

	mov		eax,msg.wParam								; Return value is wParam
														; within msg

	ret

WinMain	endp



									   ;
								  ;	WndProc
									   ;
							   ; Window	procedure
									   ;
									   ;
						; This procedure is	called when
					; a	message	is sent	to the application.
				  ;	It is the responsibility of	this procedure
			  ;	to handle all messages it wants	to handle.	If it
				   ; does not handle a message,	that message
						; must be sent to DefWindowProc,
			   ; with the same parameters that were	 passed	to it
									   ;
									   ;
								 ; Parameters:
									   ;
						  ;	hWnd:HWND -	Window handle
						   ; uMsg:UINT - The message
						; -	wParam:WPARAM -	Message	data
					  ;	lParam:LPARAM -	More message data
									   ;
									   ;
								; Return value:
									   ;
			; If the message was processed,	this procedure returns 0
			  ;	otherwise it is	the	return value of	DefWindowProc
									   ;
WndProc	proc hWnd:HWND,	uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	LOCAL hCategoryLibHandle:DWORD						; Handle to	the
														; categories.dll library
	LOCAL hCategoryFuncHandle:DWORD		; Handle to	the	displayCategoryDialog
										; function with	categories.dll

	mov	eax, uMsg								; Store	uMsg in	eax	for	quicker
												; access

	cmp	eax, WM_DESTROY							; WM_DESTROY message was sent
	je wmdestroy
	cmp	eax, WM_CREATE							; Window being created
	je wmcreate
	cmp	eax, WM_HELP							; Help message;	e.g., F1 was
	je wmhelp									; pressed

	cmp	eax, WM_SIZE							; Resizing the window
	je wmsize
	cmp	eax, WM_TIMER							; Timer	message, to	update time
	je wmtimer									; within the status	bar
	cmp	eax, WM_COMMAND							; A	control	sent a message
	je wmcommand

												; ------------------------------
										  ;	We don't need the message otherwise,
												   ; so	send it	to DefWindowProc
												; ------------------------------
	invoke DefWindowProc,hWnd,uMsg,wParam,lParam
	ret


  wmdestroy:							; Destroying the window

												; ------------------------------
											; Closing the HTML Help	API	instance
												; ------------------------------
	invoke HtmlHelp,NULL,NULL,001Dh,addr initHelp

	invoke PostQuitMessage,NULL							; Quit
	jmp	endMsgCompare

  wmcreate:								; Window was created

												; ------------------------------
														 ; Create the status bar
												; ------------------------------
	invoke CreateStatusWindow, WS_CHILD	OR WS_VISIBLE OR SBARS_SIZEGRIP,\				; styles
	NULL,\								; No text yet
	hWnd,\								; Parent
	IDC_STATUSBAR								; Identifier
	mov	hStatus, eax

	invoke setStatusParts,hWnd							; Create the parts

	invoke SendMessage,hStatus,SB_SETTEXT,1,addr gamesWon		; Games	won, second	part
	invoke SendMessage,hStatus,SB_SETTEXT,2,addr gamesLost		; Games	lost, third	part

												; ------------------------------
										 ; The timer will update the time within
												  ;	the	status bar,	every second
												; ------------------------------
	invoke SetTimer,hWnd,IDC_TIMER,1000,NULL

												; ------------------------------
												  ;	Initialize the HTML	Help API
												; ------------------------------
	invoke HtmlHelp,NULL,NULL,001Ch,addr initHelp

	jmp	endMsgCompare

  wmhelp:								; Help message
	invoke openHelpFile,hWnd							; Open up help
	jmp	endMsgCompare

  wmsize:								; Resizing the window
	invoke resizeWindow,hWnd
	jmp	endMsgCompare

  wmtimer:								; Timer	message
	invoke timerProc,wParam
	jmp	endMsgCompare

  wmcommand:							; Commands from	other controls and menus
	mov	eax, wParam								; Need to check	wParam,	so put into	eax
	and	eax, 0000FFFFh							; Clear	H.O. word of eax
												; This is so we	don't need to
												; just call	ax

						 ; messages	from the file menu
	cmp	eax, IDM_EXIT							; Exit item	of menu
	je idmexit

						 ; messages	from the edit menu
	cmp	eax, IDM_CATEGORIES								; Categories dialog
	je idmcategories

						 ; Messages	from the view menu
	cmp	eax, IDM_STATUS_BAR				; show/hide	status bar
	je idmstatusbar

						; messages from	the	Window menu
	cmp	eax, IDM_RESTORE								; Restore the window
	je idmrestore
	cmp	eax, IDM_MINIMIZE								; Minimize the window
	je idmminimize
	cmp	eax, IDM_MAXIMIZE								; Maximize the window
	je idmmaximize
	cmp	eax, IDM_HIDE							; hide the window
	je idmhide							; Do not use until there is	a system
										; tray icon	in place!
	cmp	eax, IDM_CLOSE							; Close	the	window
	je idmclose

						 ; Messages	from the help menu
	cmp	eax, IDM_HELPTOPICS								; Help topics menu item
	je idmhelptopics
	cmp	eax, IDM_LICENSE								; License information
	je idmlicense
	cmp	eax, IDM_GPL							; GPL License
	je idmgpl

	jmp	endMsgCompare

  idmexit:								; Exit menu	item
	invoke SendMessage,	hWnd, WM_CLOSE,	0, 0
	jmp	endMsgCompare

  idmcategories:								; Categories dialog	box

	dsText categoryLibName,"categories.dll"				; Create a string
	dsText categoryFuncName,"displayCategoryDialog"

	invoke LoadLibrary,	addr categoryLibName			; Load the library
	test eax, eax						; If eax contains 0, it	is invalid
	jz isInvalidCategoryLib

	mov	hCategoryLibHandle,	eax							; Store	the	handle

						; ------------------------------
						 ; Get the procedure's address
						; ------------------------------
	invoke GetProcAddress,hCategoryLibHandle,addr categoryFuncName
	test eax, eax								; If 0,	is invalid
	jz isInvalidCategoryFunc

	mov	hCategoryFuncHandle, eax								; Store	the	procedure handle

	push hWnd							; Function parameter
	call [[hCategoryFuncHandle]]
	jmp	endMsgCompare

  isInvalidCategoryFunc:								; Invalid procedure

	dsText categoryFuncOpenFailure,"The	library	categories.dll does	not	contain	the	function displayCategoryDialog",0
	invoke MessageBox,hWnd,addr	categoryFuncOpenFailure,addr libOpenFailureTitle,MB_OK OR MB_ICONEXCLAMATION
	jmp	endMsgCompare

  isInvalidCategoryLib:							; Invalid library

	dsText categoryLibOpenFailure,"The library categories.dll could	not	be opened"
	invoke MessageBox,hWnd,addr	categoryLibOpenFailure,addr	libOpenFailureTitle,MB_OK OR MB_ICONEXCLAMATION

	jmp	endMsgCompare

  idmstatusbar:							; show/hide	status bar
	invoke setStatusBar,hWnd
	jmp	endMsgCompare

  idmrestore:							; Restore the window
	invoke ShowWindow,hWnd,SW_RESTORE
	jmp	endMsgCompare

  idmminimize:							; Minimize the window
	invoke ShowWindow,hWnd,SW_MINIMIZE
	jmp	endMsgCompare

  idmmaximize:							; Maximize the window
	invoke ShowWindow,hWnd,SW_MAXIMIZE
	jmp	endMsgCompare

  idmhide:								; Hide the window
	invoke ShowWindow,hWnd,SW_HIDE
	jmp	endMsgCompare

  idmclose:								; close	the	window
	invoke SendMessage,hWnd,WM_CLOSE,0,0
	jmp	endMsgCompare

  idmhelptopics:								; Help topics display
	invoke displayHelpTopics,hWnd
	jmp	endMsgCompare

  idmlicense:							; License information
	invoke displayLicenseMsg,hWnd
	jmp	endMsgCompare

  idmgpl:								; display the GPL
	invoke showGpl,hWnd
	jmp	endMsgCompare

  endMsgCompare:

	xor	eax,eax							; Return 0
	ret

WndProc	endp


									   ;
								 ; setStatusBar
									   ;
									   ;
			; This procedure makes the status bar visible or hidden
			; depending	on the state of	the	corresponding menu item
									   ;
									   ;
								 ; Parameters:
						  ;	hWnd:HWND -	Window handle
									   ;
									   ;
								; Return values:
							   ; Always	returns	0
									   ;
setStatusBar proc hWnd:HWND

	LOCAL menuinfo:MENUITEMINFO	; MENUITEMINFO structure to	manipulate
								; the checked/unchecked	state of the menu item
	LOCAL hMenu:HMENU							; Menu handle


	invoke GetMenu,hWnd							; Retrieve menu	handle
	mov	hMenu, eax

	mov	menuinfo.cbSize, SIZEOF	MENUITEMINFO			; MENUITEMINFO size
	mov	menuinfo.fMask,	MIIM_STATE				; We're	after the item's state

												; ------------------------------
											  ;	Put	into the structure in fState
								 ; whether the menu	item is	checked	or unchecked
												; ------------------------------
	invoke GetMenuItemInfo,hMenu, IDM_STATUS_BAR, FALSE, addr menuinfo

	mov	eax,menuinfo.fState						; Store	menu item state

	cmp	eax, MFS_CHECKED						; Is it	checked?
	jne	notChecked						; Not checked, jump

	invoke ShowWindow,hStatus,SW_HIDE	; Hide status bar
	mov	eax, MFS_UNCHECKED		; MFS_UNCHECKED	into eax, to uncheck the item
	jmp	endCheck

  notChecked:					; Item is not checked
	invoke ShowWindow,hStatus,SW_SHOW					; Show the status bar
	mov	eax, MFS_CHECKED				; MFS_CHECKED to show the status bar

  endCheck:

	mov	menuinfo.fState, eax			; Store	eax	into fState, for when we
										; call SetMenuItemInfo

	invoke SetMenuItemInfo,hMenu, IDM_STATUS_BAR, FALSE, addr menuinfo

		xor	eax, eax							; Return 0
	ret

setStatusBar endp



									   ;
								 ; resizeWindow
									   ;
									   ;
			; Called when the WM_SIZE message is sent to the window.
					   ; It	just resizes the status	bar,
							; then sets	up the parts
									   ;
									   ;
								  ;	Parameters
						  ;	hWnd:HWND -	Window handle
									   ;
									   ;
								; Return value:
							   ; always	returns	0
									   ;
resizeWindow proc hWnd:HWND

		invoke SendMessage,hStatus,WM_SIZE,0,0	; resize the status	bar
	invoke setStatusParts,hWnd			; Set the status bar parts

		xor	eax, eax							; Return 0	  
	ret
resizeWindow endp


									   ;
								  ;	timerProc
									   ;
									   ;
					 ; This	procedure is called	every time
				  ;	a WM_TIMER message is sent to the window.
				  ;	It handles all timers for this application
									   ;
									   ;
								 ; Parameters:
					   ; timerId:DWORD - Timer identifier
									   ;
									   ;
								; Return value:
							   ; always	returns	0
									   ;
timerProc proc timerId:DWORD

	LOCAL systime:SYSTEMTIME					; SYSTEMTIME structure to
												; receive the current time

	.data
	timebuf	db 12 dup (0)				; buffer for the formatted time
	timeformat db "hh':'mm':'ss	tt",0			; Time format string

	.code

	mov	eax, timerId

	cmp	eax, IDC_TIMER			; Which	timer are we dealing with?
	jne	notTimer						; If it	is not IDC_TIMER, jump

	invoke GetLocalTime,addr systime			; Get the local	time

	invoke GetTimeFormat,NULL,0,addr systime,\			; Format the time
	addr timeformat,addr timebuf,lengthof timebuf

												; ------------------------------
										  ;	Set	the	sixth part of the status bar
														   ; to	the	current	time
												; ------------------------------
	invoke SendMessage,hStatus,SB_SETTEXT,5,addr timebuf

	jmp	endTimerCompare

  notTimer:

;### SEE - TODO2: ###


  endTimerCompare:

		xor	eax, eax							; Return 0
	ret

timerProc endp



									   ;
								; setStatusParts
									   ;
									   ;
					   ; Calculates	the	size of	each part
							  ;	of the status bar.
									   ;
									   ;
								 ; Parameters:
						  ;	hWnd:HWND -	Window handle
									   ;
									   ;
								; Return value:
							   ; Always	returns	0
									   ;
setStatusParts proc	hWnd:HWND

	LOCAL rcRect:RECT			; RECT for window size
	invoke GetClientRect,hWnd,addr rcRect				; Get the window's size

	mov	eax, rcRect.right						; Get the width	of the window
	sub	eax, rcRect.left
xor	edx, edx			; Zero-extend eax

	mov	ecx, 7					; 7	parts, dividing	by 7
	div	 ecx					; divide

	push ebx					; Always need to save ebx
	mov	ebx, eax

xor	ecx, ecx					; ecx is our counter

  startStatusLoop:				; Calculating the start	pos	of each	part
	mov	eax, ecx				; Store	count into eax
	mul	ebx						; Multiply status_width	/ 7	* ecx

	mov	statusParts[ecx*4],	eax			; Store	away the value

	inc	ecx
	cmp	ecx, 6			; Loop while ecx < 6
	jb startStatusLoop			; 6	is a special case, storing -1 for that

  endStatusLoop:

	pop	ebx						; done with	ebx, restore

	mov	statusParts[ecx*4],	-1			; ecx already equals 6
										; -1 means to use whatever space is	left


	invoke SendMessage,hStatus,SB_SETPARTS,7,addr statusParts	; Set parts

		xor	eax, eax							; return 0
	ret

setStatusParts endp


									   ;
								 ; openHelpFile
									   ;
									   ;
				 ; Opens and displays the help file	trivia.chm
									   ;
									   ;
								 ; Parameters:
						  ;	hWnd:HWND -	Window handle
									   ;
									   ;
								; Return value:
							   ; always	returns	0
									   ;
openHelpFile proc hWnd:HWND

	LOCAL hHelp:HWND							; Help window handle

	invoke HtmlHelp,hWnd,addr helpFileName,0,NULL		; Open the help	file
	mov	hHelp, eax

												; ------------------------------
												; Set the help window's	position
												; ------------------------------
	invoke SetWindowPos,hHelp,HWND_TOP,0,0,700,500,SWP_NOZORDER

	xor	eax, eax							; return 0
	ret

openHelpFile endp

include	menuitems.asm			; menuitems.asm	contains other procedures

end	start
